/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
void mainWindow::init()
{

    book=NULL ;
    editMode = new QLabel(this) ;
    editMode->setText("Unmodified") ;
    statusBar()->addWidget(editMode,0,TRUE);
    fileName = new QLabel(this) ;
    fileName->setText("None") ;
    statusBar()->addWidget(fileName,0,TRUE) ;

}

void mainWindow::fileNew()
{
    int response = QMessageBox::Yes ;
    if (book != NULL)
    {
	if (book->bookEdited())
	{
	    // promt to save
	    if (QMessageBox::Yes == (response = QMessageBox::question(this, "Save file?", "File has been edited. Save?", QMessageBox::Yes, QMessageBox::No ,QMessageBox::Cancel)))
		book->saveBook("") ;
	}
	if (response != QMessageBox::Cancel) 
	    delete book ;
    }
    if (response != QMessageBox::Cancel)
    {
	book = new widgetBook(this) ;
	setCentralWidget(book) ;
	book->newBook() ;
	book->clearEdit() ;
	connect( book , SIGNAL( editChange(bool) ) , this, SLOT(editChange(bool)));
	book->show() ;
	fileName->setText("Untitled") ;
	editMode->setText("Unmodified") ;
    }

}


void mainWindow::fileOpen()
{
    int response = QMessageBox::Yes ;
    if (book != NULL)
    {
	if (book->bookEdited())
	{
	    // promt to save
	    if (QMessageBox::Yes == (response = QMessageBox::question(this, "Save file?", "File has been edited. Save?", QMessageBox::Yes, QMessageBox::No ,QMessageBox::Cancel )))
		book->saveBook("") ;
	}
	if (response != QMessageBox::Cancel)
	    delete book ;
    }
    if (response != QMessageBox::Cancel)
    {
	book = new widgetBook(this) ;

	QString s = QFileDialog::getOpenFileName ( QString::null,  "Books (*.bok);; All Files (*.*) ", this,  0, "Open File") ;
	fileName->setText(s)  ;
	book->openBook(s) ;
	book->clearEdit() ;
	connect( book , SIGNAL( editChange(bool) ) , this, SLOT(editChange(bool)));

	setCentralWidget(book) ;
	book->show() ;
    }

}


void mainWindow::fileSave()
{
    if (book!= NULL)
	book->saveBook("") ;
    editMode->setText("Unmodified") ;
}


void mainWindow::fileSaveAs()
{
    if (book != NULL)
    {
	QString filename = QFileDialog::getSaveFileName ( QString::null, "Book (*.bok);;All Files (*.*)", this, 0, "Save as" ) ;
	if (!filename.isEmpty())
	{
	    book->saveBook(filename) ;
	    fileName->setText(filename) ;
	    editMode->setText("Unmodified") ;
	}
	
    }
}




void mainWindow::fileExit()
{
    if (fileClose())
	close() ;
	

}



void mainWindow::helpAbout()
{
    QMessageBox::information(this,"Book Editor","Version 1.21",QMessageBox::Ok) ;
}


void mainWindow::editChange( bool value )
{
    editMode->setText("Modified") ;
}


bool mainWindow::fileClose()
{
    bool rvalue = true ;
    int response = QMessageBox::Yes ;
   if (book != NULL)
    {
	if (book->bookEdited())
	{
	    // promt to save
	    if (QMessageBox::Yes ==(response = QMessageBox::question(this, "Save file?", "File has been edited. Save?", QMessageBox::Yes, QMessageBox::No ,QMessageBox::Cancel)))
		book->saveBook("") ;
	}
	if (response != QMessageBox::Cancel)
	{
	    delete book ;
	    book = NULL ;
	    fileName->setText("None") ;
	    editMode->setText("Unmodified") ;
	}
	else
	    rvalue = false ;
    }
   return rvalue ;
}


void mainWindow::fileExport()
{
    if (book != NULL)
    {
	QString name = fileName->text() ;
	QFileInfo info(name) ;
	name = info.filePath() + "/" + info.baseName() + ".scp" ;
	QString filename = QFileDialog::getSaveFileName ( name,QString::null , this, 0, "Export as" ) ;
	if (!filename.isEmpty())
	{
	    book->exportBook(filename) ;
	}
	
    }
}
