/****************************************************************************
** ui.h extension file, included from the uic-generated form implementation.
**
** If you wish to add, delete or rename functions or slots use
** Qt Designer which will update this file, preserving your code. Create an
** init() function in place of a constructor, and a destroy() function in
** place of a destructor.
*****************************************************************************/
void widgetBook::init()
{
    QWidget  *temp = widgetStack1->visibleWidget() ;
    if (temp != NULL)
    {
	widgetStack1->removeWidget(temp) ;
	delete temp ;
    }
    edit = false ;
    newfile =false;
    sentedit = false ;
}

bool widgetBook::openBook( QString input )
{
    bool rvalue = false ;
    filename = input ;
    QFile file(input) ;
    if (file.open(IO_ReadOnly) )
    {
	
	QDataStream stream(&file) ;
	stream.setByteOrder(QDataStream::LittleEndian) ;
	QString tinput ;
	char input[62] ;
	stream.readRawBytes(input,62) ;
	input[61] = 0 ;
	tinput = QString::fromUtf8(input) ;
	lineTitle->setText(tinput) ;
	stream.readRawBytes(input,32) ;
	input[31] = 0 ;
	tinput = QString::fromUtf8(input) ;

	lineAuthor->setText(tinput) ;
	int numpages ;
	stream.readRawBytes(input,5) ;
	tinput = QString::fromUtf8(input) ;

	numpages = QString(tinput).toLong() ;
	maxpages = numpages ;
	spinNumPage->setValue(numpages) ;
	clearEdit() ;
	for (int i = 0 ; i < numpages ; ++i)
	{
	    bookPage* page = new bookPage(this) ; 

	    stream.readRawBytes(input,1) ; // skip past the cr
	    for (int j = 0 ; j < 8 ; ++j)
	    {
		stream.readRawBytes(input,34) ;
		input[33] = 0 ;
		tinput = QString::fromUtf8(input) ;

		page->setLine(j,tinput) ;
		
	    }
	    widgetStack1->addWidget(page,i+1) ;
	    connect(page, SIGNAL( editChange(bool) ) , this, SLOT(slotEdit(bool)));
	    page->clearEdit() ;
	}
	widgetStack1->raiseWidget(1) ;
	textPage->setText("Page 1 of " + QString::number(numpages)) ;
	rvalue = true ;
    }
	
    return rvalue ;
    
}


bool widgetBook::newBook(  )
{
    bool rvalue =true ;
    newfile = true ;
    maxpages = spinNumPage->value() ;

    for (int i = 0 ; i < maxpages ; ++i)
    {
	bookPage* page = new bookPage(this) ; 
	widgetStack1->addWidget(page,i+1) ;
    }
    widgetStack1->raiseWidget(1) ;
    textPage->setText("Page 1 of " + QString::number(maxpages)) ;
    
    return rvalue ;
}


bool widgetBook::saveBook( QString input )
{
    bool rvalue = false ;
    if (input.isEmpty() && newfile)
    {
	filename = QFileDialog::getSaveFileName (  QString::null,  QString::null, this,  0, "Save file") ; // Prompt for a filename
	newfile = false ;
    }
    else if (!input.isEmpty())
    {
	filename = input ;
	newfile = false ;
    }
    clearEdit() ;
    QFile file(filename)  ;
    file.open(IO_WriteOnly) ;
    QDataStream stream(&file) ;
    stream.setByteOrder(QDataStream::LittleEndian) ;
    char output[62] ;
    QString temp = lineTitle->text() ;
    temp.truncate(61)  ;
    for (unsigned int index = 0 ; index < temp.length() ; ++index)
    {
	output[index] = temp.utf8()[ ( int)(index) ] ;
    }
    output[temp.length()] = 0 ;
    output[61] = '\n' ;
    
    stream.writeRawBytes(output,62) ;
    
    temp = lineAuthor->text() ;
    temp.truncate(31)  ;
    for (unsigned int index = 0 ; index < temp.length() ; ++index)
    {
	output[index] = temp.utf8()[(int)index] ;
    }
    output[temp.length()] = 0 ;
    output[31] = '\n' ;
    
    stream.writeRawBytes(output,32) ;
    
    // Number of pages, in ascii
    temp = QString::number(maxpages) ;
    output[0]  =  0 ;
    output[1] = 0 ;
    output[2] = 0 ;
    output[3] = 0 ;
    for (unsigned int index = 0 ; index < temp.length() ; ++index)
    {
	output[index] = temp.utf8()[static_cast<int>(index)] ;
    }
    output[4] = '\n' ;
    stream.writeRawBytes(output,5) ;
    
    for (int i = 1 ; i <= maxpages; ++i)
    {
	output[0] = '\n' ;
	stream.writeRawBytes(output,1) ;
	bookPage* page = (bookPage*)widgetStack1->widget(i) ;
	for (int jj = 0 ; jj < 8 ; ++jj)
	{
	    QString line = page->getLine(jj) ;
	    page->clearEdit() ;
	    line.truncate(33) ;
	    for (unsigned int index = 0 ; index < line.length() ; ++index)
	    {
		output[index] = line.utf8()[(int)index] ;
	    }
	    output[line.length()] = 0 ;
	    output[33] = '\n' ;
	    stream.writeRawBytes(output,34) ;
	    
	}

    }
    
    return rvalue ;

}


bool widgetBook::bookEdited()
{
    bool rvalue = false ;
    rvalue = edit || newfile  || lineTitle->isModified() || lineAuthor->isModified();
    if (!rvalue )
    {
	// No pages added or deleted
	for (int id = 1 ; id <= maxpages ; ++id)
	{
	    bookPage* temp = (bookPage*)widgetStack1->widget(id)  ;
	    rvalue = temp->edited() ;
	    if (rvalue)
		break ;
	}
	
    }
    
    return rvalue ;

}


void widgetBook::bookBack()
{
    QWidget* temp = widgetStack1->visibleWidget() ;
    int id = widgetStack1->id(temp) ;
    if (id > 1)
    {
	widgetStack1->raiseWidget(id-1) ;
	textPage->setText("Page " + QString::number(id-1) + " of " + QString::number(spinNumPage->value())) ;
    }
}


void widgetBook::bookForward()
{
    QWidget* temp = widgetStack1->visibleWidget() ;
    int id = widgetStack1->id(temp) ;
    if (id <spinNumPage->value())
    {
	widgetStack1->raiseWidget(id+1) ;
	textPage->setText("Page " + QString::number(id+1) + " of " + QString::number(spinNumPage->value())) ;
    }

}


void widgetBook::bookPageChange( int value )
{
    int curpage = widgetStack1->id(widgetStack1->visibleWidget()) ;
    QWidget* temp = NULL ;
    if (value < maxpages)
    {
	edit = true ;
	if (curpage > value) 
	{
	    curpage = value ;
	    widgetStack1->raiseWidget(value) ;
	}
	
	
	// we delete the pages we dont want
	
	for (int id = maxpages; id > value ; --id)
	{
	    temp = widgetStack1->widget(id) ;
	    if (temp != NULL)
	    {
		widgetStack1->removeWidget(temp) ;
		delete temp ;
	    }
	}
	maxpages = value ;
	textPage->setText("Page " + QString::number(curpage) + " of " + QString::number(value) ) ;
	slotEdit(true) ;
	
	
    }
    else if (value > maxpages)
    {
	edit = true ;
	for (int id = maxpages+1 ;  id <= value ; ++ id)
	{
	    bookPage* page = new bookPage(this) ; 
	    widgetStack1->addWidget(page,id) ;
	}
	maxpages = value ;
	textPage->setText("Page " + QString::number(curpage) + " of " + QString::number(value) ) ;
	slotEdit(true) ;
	       
	
	
	
    }
}


void widgetBook::slotEdit( bool value )
{
    if (!sentedit)
    {
	editChange(true) ;
	sentedit = true ;
    }
}


void widgetBook::slotEdit( const QString & value )
{
    slotEdit(true) ;
}


void widgetBook::clearEdit()
{
    sentedit = false ;
    edit = false ;
    lineTitle->clearModified() ;
    lineAuthor->clearModified() ;

}

void widgetBook::exportBook( QString value )
{

    QFile file ;
    unsigned int numpages ;
    file.setName(value) ;
    if (file.open(IO_WriteOnly) )
    {

	QTextStream stream(&file) ;
	//stream.setEncoding(QTextStream::Locale) ;
	stream << "SECTION BOOK" << endl ;
	stream << "{" << endl  ;
	stream << "PAGES " << spinNumPage->value() << endl;
	stream << "TITLE " << lineTitle->text() << endl;
	stream <<"AUTHOR " << lineAuthor->text() << endl ;
	numpages = spinNumPage->value() ;
	for (unsigned int i = 0 ; i < numpages ; ++i)
	{
	    stream << "PAGE " << i << endl ;
	}
	stream << "}" << endl ;
	
	for (unsigned int i=0 ; i < numpages ; ++i)
	{
	    stream << "SECTION PAGE " << i << endl ;
	    stream << "{" << endl ;
	    bookPage* page = (bookPage*)widgetStack1->widget(i+1) ;
	    for (int j = 0 ; j < 8 ; ++j)
	    {
		QString line = page->getLine(j) ;
		stream << line << endl ;
	    }
	    stream << "}" << endl ;
	}
	file.close() ;
    }

    }

